<template>
  <q-page style="background-color: white">
    <div class="row no-wrap full-height">
      <div class="col column" style="margin: 5px">
        <div class="col">
          <Container class="container" :dscene="scene" />
        </div>
        <div class="col-grow row" style="height: 275px">
          <TaskList
            class="col task-list"
            :tasks="taskList"
            :selected="selected"
            @selected="handleSelected"
            @deleted="handleDeleted"
            @save="handleSave"
          />
          <q-scroll-area class="column col-5 justify-end items-center" style="padding: 0.5em;">
            <div class="col-3 row justify-center">
              <div v-if="$props.editorMode" class="row justify-center">
                <q-btn round icon="play_arrow" color="teal" size="md" />
              </div>
              <q-btn
                v-else
                class="col-3"
                size="lg"
                label="Pick"
                icon="mdi-arrow-right-thick"
                color="primary"
                @click="handlePick"
              />
            </div>
            <Recap class="col-9 self-center" :scene="scene" />
          </q-scroll-area>
        </div>
      </div>
      <div class="col-shrink column">
        <node-container class="node-container" />
      </div>
    </div>
  </q-page>
</template>

<script lang="ts">
import Container from 'components/task/workflow/Container.vue';
import TaskList from 'components/task/tasklist/TaskList.vue';
import NodeContainer from 'components/task/nodes/NodeContainer.vue';
import Recap from 'components/task/taskmanager/Recap.vue';

import { onMounted, ref } from 'vue';
import { useQuasar } from 'quasar';
import { useRouter } from 'vue-router';
import { Scene } from 'src/models/workflow';
import { TaskFile } from 'src/models/files';
import { successNotification } from 'src/components/notifications';
import { useStore } from 'src/store';
import { scene2task } from 'src/components/task/tree';
import { refineTask, refinedToLoopmap } from 'src/components/conversions';

export default {
  name: 'Task',
  components: {
    Container,
    TaskList,
    NodeContainer,
    Recap,
  },
  props: {
    editorMode: {
      default: false,
      type: Boolean,
    },
  },
  setup() {
    const $store = useStore();
    const $router = useRouter();
    const $q = useQuasar();
    const scene = ref({
      nodes: [],
      blocks: [],
      links: [],
      container: {
        center: { x: 0, y: 0 },
        scale: 1,
      },
    } as Scene);

    let taskList = ref(['']);
    const selected = ref('');

    const untitled = () => {
      selected.value = '';
      /*
      scene.value = {
        nodes: [],
        blocks: [],
        links: [],
        container: {
          center: { x: 0, y: 0 },
          scale: 1,
        },
      } as Scene;
      */
      const block = $store.state.experiment.currentExperiment.blocks.find(
        (bblock) => bblock.id === $store.state.experiment.editingBlockID
      );
      if (block && block.rawTemplate !== null) scene.value = JSON.parse(JSON.stringify(block.rawTemplate)) as Scene;
    };

    onMounted(() => {
      void window.taskApi.listTasks().then((list) => {
        taskList.value = list;
      });
      untitled();
    });

    window.taskApi.onAdded((filename) => {
      taskList.value.push(filename);
      handleSelected(filename);
    });

    window.taskApi.onRemoved((filename) => {
      taskList.value = taskList.value.filter((name) => name !== filename);
    });

    const handleSelected = (event: string) => {
      selected.value = event;
      void window.taskApi.readTask(event).then((data: string) => {
        const save = JSON.parse(data) as TaskFile;
        scene.value = save.scene;
      });
    };

    const handleDeleted = (event: string) => {
      if (event === selected.value) untitled();
    };

    const save = () => {
      void window.taskApi
        .writeTask({
          name: selected.value,
          version: '0.0.1',
          scene: JSON.parse(JSON.stringify(scene.value)) as Scene,
        })
        .then((res) => {
          successNotification('Task saved!');
        });
    };

    const handleSave = () => {
      if (selected.value.length === 0) {
        $q.dialog({
          title: 'New task',
          message: 'Insert a name for your new task',
          prompt: {
            model: 'Custom task',
            type: 'text', // optional
          },
          cancel: true,
          persistent: true,
        })
          .onOk((data: string) => {
            window.taskApi
              .writeTask({
                name: data,
                version: '0.0.1',
                scene: JSON.parse(JSON.stringify(scene.value)) as Scene,
              })
              .catch((err) => console.log(err))
              .then((res) => console.log(res))
              .catch((err) => console.log(err));
          })
          .onCancel(() => {
            // console.log('>>>> Cancel')
          })
          .onDismiss(() => {
            // console.log('I am triggered on both OK and Cancel')
          });
      } else save();
    };

    const handlePick = () => {
      const rawScene = JSON.parse(JSON.stringify(scene.value)) as Scene;
      const rawTask = scene2task(rawScene);
      const refined = refineTask(rawTask);
      const loopMap = refinedToLoopmap(refined);
      const blockToUpdate = $store.state.experiment.currentExperiment.blocks.find(
        (bblock) => bblock.id === $store.state.experiment.editingBlockID
      );
      if (blockToUpdate)
        $store.commit('experiment/updateBlock', {
          id: blockToUpdate.id,
          rawTemplate: rawScene,
          template: refined,
          loopMap: loopMap,
          queue: [refined],
        });

      $store.commit('experiment/setEditingBlock', '');
      void $router.push('/experiment');
    };

    return {
      scene,
      selected,
      taskList,
      handlePick,
      handleSelected,
      handleDeleted,
      handleSave,
    };
  },
};
</script>

<style lang="sass" scoped>
q-page
  height: 100%
.container
  width: 100%
  height: 650px
  border-bottom: 1px solid #bbb
  border-right: 1px solid #bbb
.node-container
  width: 350px
  height: 85%
.task-list
  width: 40%
  margin: 16px 16px
</style>
